<template>
  <PageWrapper dense>
   
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button
              @click="
                downloadExcel(
                  rescueInfoExport,
                  '救援站信息;数据',
                  getForm().getFieldsValue()
                )
              "
              v-auth="'elevator:rescueInfo:export'"
              >导出</a-button
            >
            <a-button
              type="primary"
              danger
              @click="multipleRemove(rescueInfoRemove)"
              :disabled="!selected"
              v-auth="'elevator:rescueInfo:remove'"
              >删除</a-button
            >
            <a-button type="primary" @click="handleAdd" v-auth="'elevator:rescueInfo:add'"
              >新增</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',
                    icon: IconEnum.PREVIEW,
                    type: 'primary',
                    ghost: true,
                    auth: 'rescue:rescueInfo:query',
                    onClick: handCheck.bind(null, record),
                  },
                  {
                    label: '修改',
                    icon: IconEnum.EDIT,
                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:rescueInfo:edit',
                    onClick: handleEdit.bind(null, record),
                  },
                  {
                    label: '删除',
                    icon: IconEnum.DELETE,
                    type: 'primary',
                    danger: true,
                    ghost: true,
                    auth: 'elevator:rescueInfo:remove',
                    popConfirm: {
                      placement: 'left',
                      title: '是否删除救援站信息;[' + record.id + ']?',
                      confirm: handleDelete.bind(null, record),
                    },
                  },
                ]"
              />
            </template>
          </template>
        </BasicTable>
      

    <RescueInfoModal @register="registerModal" @reload="reload" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { Row, Col } from "ant-design-vue";
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import {
  rescueInfoList,
  rescueInfoExport,
  rescueInfoRemove,
} from "@/api/basicInfo/securityInfo";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import RescueInfoModal from "./RescueInfoModal.vue";
import { formSchemas, columns } from "./rescueInfo.data";
import { IconEnum } from "@/enums/appEnum";
import RescueInfoDeptTree from "./RescueInfoDeptTree.vue";
import { ref, toValue } from "vue";
defineOptions({ name: "RescueInfo" });
// 左边部门用
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "救援站信息;列表",
  api: rescueInfoList,
  showIndexColumn: true,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      await reload();
    },
  },
  columns: columns,
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  actionColumn: {
    width: 250,
    title: "操作",
    key: "action",
    fixed: "right",
  },
});

const [registerModal, { openModal }] = useModal();

function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}

function handleAdd() {
  openModal(true, { update: 2 });
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
async function handleDelete(record: Recordable) {
  await rescueInfoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
